#!/system/bin/sh

until [ `getprop sys.boot_completed` -eq 1 ]
do
	sleep 1
done

Module() \
{
	sed -i "/^$1=/c $1=$2" ${0%/*}/module.prop
}

until Time=$((`date +%Y%m%d%H%M%S` - `uptime -s | tr -d \ :-`))
	[ $Time -gt 120 ]
do
	Module name "文件归类&软链 #$((120 - $Time))秒后运行"
	sleep 1
done

Tmp=${0%/*}/sbin
export PATH=$PATH:$Tmp
[ ! -d $Tmp ] && \
{
	mkdir $Tmp
	`find /data/adb -name busybox | head -n 1` --install -s $Tmp
}

Main_Folder=/data/.文件软链
Name=文件软链配置.rc
Conf_1=/data/media/0/Android/$Name
Conf_2=${0%/*}/$Name
IFS=$'\n'

Ln_Folder() \
{
	Folder=$Main_Folder/$1
	mkdir -p "$Folder"
	Ln_Tmp=$Folder/`basename "$File"`
	[ ! -e "$Ln_Tmp" ] && \
		ln -s "$File" "$Ln_Tmp"
}


Ln_File() \
{
	for File in "$1"/*
	do
		[ ! -f "$File" ] && continue
		case "$File" in
			*.txt|*.md)
				Ln_Folder 文本
				;;
			*.zip|*.rar|*.7z|*.tar|*.gz|*.bz2)
				Ln_Folder 压缩包
				;;
			*.jpg|*.tiff|*.jpeg|*.png|*.gif|*.bmp|*.svg|*.ico|*.swf|*.webp)
				Ln_Folder 图片
				;;
			*.apk|*.1|*.apks)
				Ln_Folder 安装包
				;;
			*.htm|*.html|*.sh|*.rc|*.java|*.js|*.json|*.vue|*.php|*.py|*.bat|*.gitignore|*.yml|*.go|*.c|*.cpp|*.h|*.hpp|*.tsx|*.vtt|*.srt|*.ass|*.rs|*.lrc|*.lua)
				Ln_Folder 代码
				;;
			*.xml|*.ini|*.conf|*.properties|*.prop)
				Ln_Folder 配置
				;;
			*.db|*.sql|*.mdb|*.accdb|*.frm|*.bak|*.log)
				Ln_Folder 数据库
				;;
			*.mp4|*.mkv|*.avi|*.mov|*.rmvb|*.webm|*.flv|*.m3u8)
				Ln_Folder 视频
				;;
			*.ttf)
				Ln_Folder 字体
				;;
			*.doc|*.docx|*.pdf|*.rtf|*.odt|*.wps)
				Ln_Folder 文档
				;;
			*.mp3|*.flac|*.ogg|*.m4a|*.wav|*.opus|*.wma)
				Ln_Folder 音频
				;;
			*.*)
				Ln_Folder 其他
				;;
		esac
	done
}

Server() \
{
	find $Main_Folder -type l -exec test ! -e {} \; -delete 2>/dev/null
	for Sub_Folder in `tail -n +9 $Conf_2`
	do
		[ -d "$Sub_Folder" ] && \
			Ln_File "$Sub_Folder"
	done
	Module name "文件归类&软链 #已软链`find $Main_Folder -type l | wc -l`个文件"
} 2>${0%/*}/Error.log

Module name "文件归类&软链 #统计中..."

while true
do
	[ -f $Conf_1 ] && \
		cp -rf $Conf_1 $Conf_2 || \
			cp -rf $Conf_2 $Conf_1
	eval "`sed -n '2,6p' $Conf_2`"
	if [ $Mode = 1 ] ;then
		Module version "间隔模式：$Period"
		Server
		sleep $Period
	elif [ $Mode = 2 ] ;then
		Module version "定时模式：$Time"
		[ `date +%H:%M` = $Time ] && \
			Server
		sleep 5
	fi
done